Attribute VB_Name = "SFMpqMain"
Option Explicit

Public MpqInitialized As Boolean, ConsoleAllocated As Boolean, StdIn As Long, StdOut As Long, StdErr As Long

Declare Function AllocConsole Lib "Kernel32" () As Boolean
Declare Function FreeConsole Lib "Kernel32" () As Boolean
Declare Function SetConsoleTitle Lib "Kernel32" Alias "SetConsoleTitleA" (ByVal lpConsoleTitle As String) As Boolean
Declare Function CreateFile Lib "Kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Declare Function CloseHandle Lib "Kernel32" (ByVal hObject As Long) As Boolean
Declare Function WriteFile Lib "Kernel32" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Any) As Boolean
Declare Function ReadFile Lib "Kernel32" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Boolean

Const GENERIC_READ      As Long = &H80000000
Const GENERIC_WRITE     As Long = &H40000000
Const OPEN_EXISTING     As Long = 3
Const FILE_SHARE_READ   As Long = &H1
Const FILE_SHARE_WRITE  As Long = &H2

Const UseBanner As String = "                Usage:  mpq <command> <archive_name> <file_names>\n" _
                          + "  Add or replace file:  mpq a <archive_name> <file_name> <packed_name>\n" _
                          + "     Add uncompressed:  mpq A <archive_name> <file_name> <packed_name>\n" _
                          + "          Delete file:  mpq d <archive_name> <file_name>\n" _
                          + "         Extract file:  mpq e <archive_name> <packed_name> [target_directory]\n" _
                          + "Extract with pathname:  mpq x <archive_name> <packed_name> [target_directory]\n" _
                          + "        List archive :  mpq l <archive_name> [listfile1] [listfile2] [...]\n"

Dim Mpq As MpqControl
Function cputs(ByVal TextOut As String) As Long
Dim cNum As Long
If StdOut = -1 Then Exit Function
For cNum = 1 To Len(TextOut)
    cNum = InStr(cNum, TextOut, "\n", 1)
    If cNum > 0 Then
        Mid(TextOut, cNum, 2) = vbCrLf
    Else
        Exit For
    End If
Next cNum
cputs = Not WriteFile(StdOut, TextOut, Len(TextOut), 0&, 0&)
End Function
Sub printf(ByVal TextOut As String)
Dim cNum As Long
If StdOut = -1 Then Exit Sub
For cNum = 1 To Len(TextOut)
    cNum = InStr(cNum, TextOut, "\n", 1)
    If cNum > 0 Then
        Mid(TextOut, cNum, 2) = vbCrLf
    Else
        Exit For
    End If
Next cNum
WriteFile StdOut, TextOut, Len(TextOut), 0&, 0&
End Sub
Sub Main()
Dim sLine As String, pNum As Long, Endargv As Long, argvCutout As String, argc As Long, argv() As String
Load Form1
Set Mpq = Form1.Mpq
sLine = Command
StartProgram:
If Right(sLine, 1) <> " " Then sLine = sLine + " "
ReDim argv(0) As String
argv(0) = App.Path
If Right(argv(0), 1) <> "\" Then argv(0) = argv(0) + "\"
argv(0) = argv(0) + App.EXEName + ".exe"
If sLine <> "" Then
    For pNum = 1 To Len(sLine)
        If Mid(sLine, pNum, 1) = Chr(34) Then
            pNum = pNum + 1
            Endargv = InStr(pNum, sLine, Chr(34))
            If UBound(argv) = 1 Then argvCutout = Mid(sLine, pNum - 1, (Endargv + 1) - (pNum - 1))
        Else
            Endargv = InStr(pNum, sLine, " ")
            If UBound(argv) = 1 Then argvCutout = Mid(sLine, pNum, Endargv - pNum)
        End If
        If Endargv = 0 Then Endargv = Len(sLine) + 1
        If pNum <> Endargv Then
            If Trim(Mid(sLine, pNum, Endargv - pNum)) <> "" Then
                ReDim Preserve argv(UBound(argv) + 1) As String
                argv(UBound(argv)) = Trim(Mid(sLine, pNum, Endargv - pNum))
            End If
        End If
        pNum = Endargv
    Next pNum
End If
argc = UBound(argv) + 1
SetConsoleTitle App.Title + " " + sLine
StdIn = CreateFile("CON", GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0)
StdOut = CreateFile("CON", GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0)
MpqMain argc, argv
SetConsoleTitle App.Title
If StdIn <> -1 And StdOut <> -1 And argc = 1 Then
    cputs "\nCommand: "
    pNum = 0
    sLine = String(255, Chr(0))
    ReadFile StdIn, sLine, Len(sLine), pNum, 0&
    If InStr(sLine, Chr(0)) Then sLine = Left(sLine, InStr(sLine, Chr(0)) - 1)
    sLine = Left(sLine, Len(sLine) - 2)
    If sLine <> "" And LCase(sLine) <> "exit" And LCase(sLine) <> "quit" Then
        CloseHandle StdIn
        GoTo StartProgram
    End If
End If
If StdIn <> -1 Then CloseHandle StdIn
If StdOut <> -1 Then CloseHandle StdOut
Unload Form1
End Sub
Sub MpqMain(argc As Long, argv() As String)
Dim tc As String
  If MpqInitialized = False Then
    If Mpq.MpqInitialize() = False Then
      cputs "Can't initialize LMPQAPI.dll\n"
      Exit Sub
    End If
    MpqInitialized = True
  End If

'    printf "LMPQDLL demo program v1.2 Copyright (c) 1999 Andrey V. Lelikov\n"
'  cputs "This programs uses ": cputs Mpq.MpqGetVersionString(): cputs "\n\n"

    If argc < 3 Then
banner:
        cputs Mpq.GetTitle + vbCrLf + vbCrLf + UseBanner
        Exit Sub
    End If
  Select Case argv(1)
  Case "a"
    If argc >= 5 Then
        Mpq.AddFile argv(2), argv(3), argv(4), 1
    ElseIf argc >= 4 Then
        ReDim Preserve argv(4) As String
        argv(4) = argv(3)
        tc = InStr(argv(4), ":")
        If tc <> 0 Then
            argv(4) = Mid(argv(4), tc + 1)
            If Left(argv(4), 1) = "\" Then
                argv(4) = Mid(argv(4), 2)
            End If
        End If
        Mpq.AddFile argv(2), argv(3), argv(4), 1
    Else
        GoTo banner
    End If
  Case "A"
    If argc >= 5 Then
        Mpq.AddFile argv(2), argv(3), argv(4), 0
    ElseIf argc >= 4 Then
        ReDim Preserve argv(4) As String
        argv(4) = argv(3)
        tc = InStr(argv(4), ":")
        If tc <> 0 Then
            argv(4) = Mid(argv(4), tc + 1)
            If Left(argv(4), 1) = "\" Then
                argv(4) = Mid(argv(4), 2)
            End If
        End If
        Mpq.AddFile argv(2), argv(3), argv(4), 0
    Else
        GoTo banner
    End If
  Case "d", "D"
    If argc >= 4 Then
        Mpq.DelFile argv(2), argv(3)
    Else
        GoTo banner
    End If
  Case "l", "L"
    If argc >= 4 Then
        Mpq.ListFiles argv(2), argv(3)
    ElseIf argc >= 3 Then
        Mpq.ListFiles argv(2), ""
    Else
        GoTo banner
    End If
  Case "e", "E"
    If argc >= 5 Then
        Mpq.GetFile argv(2), argv(3), argv(4), False
    ElseIf argc >= 4 Then
        Mpq.GetFile argv(2), argv(3), ".", False
    Else
        GoTo banner
    End If
  Case "X", "x"
    If argc >= 5 Then
        Mpq.GetFile argv(2), argv(3), argv(4), True
    ElseIf argc >= 4 Then
        Mpq.GetFile argv(2), argv(3), ".", True
    Else
        GoTo banner
    End If
  Case Else
    GoTo banner
  End Select
End Sub
